package guiaModernismo.controller;

import guiaModernismo.comparators.OrdenarContenidoPorOrden;
import guiaModernismo.dao.BusquedaDAO;
import guiaModernismo.dao.ContactoDAO;
import guiaModernismo.dao.MediaDAO;
import guiaModernismo.dao.PaginaIdiomaDAO;
import guiaModernismo.dao.VisitasDAO;
import guiaModernismo.model.Bloque;
import guiaModernismo.model.Bloquemarcador;
import guiaModernismo.model.BreadCrumbUrl;
import guiaModernismo.model.Busqueda;
import guiaModernismo.model.Contacto;
import guiaModernismo.model.ContenidoPagina;
import guiaModernismo.model.Marcadores;
import guiaModernismo.model.Media;
import guiaModernismo.model.Paginaidioma;
import guiaModernismo.model.Visitas;

import java.io.IOException;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.primefaces.model.menu.DefaultMenuItem;
import org.primefaces.model.menu.DefaultMenuModel;
import org.primefaces.model.menu.MenuElement;
import org.primefaces.model.menu.MenuModel;

@ManagedBean
@SessionScoped
public class GuiaModernismoController implements Serializable {

	@Inject
	private PaginaIdiomaDAO paginaIdiomaDAO;

	@Inject
	private VisitasDAO visitasDAO;

	@Inject
	private ContactoDAO contactoDAO;

	@Inject
	private MediaDAO mediaDAO;

	@Inject
	private BusquedaDAO busquedaDAO;

	public String pagActual;

	public String tipusActual;

	public String idParam = "";

	public String ultimoIdBread;

	public String idFrame = "";

	public Paginaidioma paginaidioma;

	public String indexBread = "";

	public String idUrl = "";

	public String idFoto = "";

	public String idVimeo = "";

	public String txtSearch = "";

	public List<BreadCrumbUrl> lBreadCrumbUrl = new ArrayList<BreadCrumbUrl>();

	public List<Busqueda> lBusqueda = new ArrayList<Busqueda>();

	public String flagSearch = "";

	public Contacto contacto = new Contacto();

	MenuModel breadCrumb = new DefaultMenuModel();
	Integer nBreadCrumb = 0;

	public List<Bloque> lBloquesPag = new ArrayList<Bloque>();

	public GuiaModernismoController() {

	}

	public void cambiarIdioma(String idioma) {

	}

	public Paginaidioma getPaginaidioma() {

		return paginaidioma;
	}

	public int id;

	public void submit() {

		Visitas visitas = new Visitas();

		String cadenaConexion = "";

		int iT = 0;

		String tParam = "";
		String iParam = "";

		if (!idParam.equals("")) {
			iT = idParam.indexOf(",");

			tParam = idParam.substring(iT + 1, idParam.length());

			if (tParam.equals("PAGINAIDIO")) {
				idUrl = idParam.substring(0, iT - 1);
			}

			if (tParam.equals("FOTO")) {
				idFoto = idParam.substring(0, iT - 1);
			}

			if (tParam.equals("VIMEO")) {
				idVimeo = idParam.substring(0, iT);
			}

			if (tParam.equals("IFRAME")) {
				idFrame = idParam.substring(0, iT);
			}

			idParam = "";
		}

		if (!flagSearch.equals("true")) {

			if (idFoto != null && !idFoto.equals("")) {
				cadenaConexion = "FOTO " + idFoto + " , ";

				fabricaPaginaFoto();
			} else {
				if (idUrl != null && !idUrl.equals("")) {
					cadenaConexion = "PAGINAIDIO " + idUrl + " , ";

					fabricaPagina();
				} else {
					if (idVimeo != null && !idVimeo.equals("")) {
						cadenaConexion = "VIMEO " + idVimeo + " , ";

						fabricaPaginaVimeo();
					} else {
						if (idFrame != null && !idFrame.equals("")) {
							cadenaConexion = "IFRAME " + idFrame + " , ";

							fabricaPaginaIframe();
						} else {

							idUrl = "1";
							cadenaConexion = "PAGINAIDIO " + idUrl + " , ";

							gestBreadCrumb("1", "1");
							fabricaPagina();
						}
					}
				}
			}

			idFoto = "";
			idUrl = "";
			idVimeo = "";
			idFrame = "";

		}

		try {
			HttpServletRequest req = (HttpServletRequest) FacesContext
					.getCurrentInstance().getExternalContext().getRequest();
			HttpServletResponse res = (HttpServletResponse) FacesContext
					.getCurrentInstance().getExternalContext().getResponse();

			cadenaConexion += req.getRemoteAddr() + " , " + req.getRemoteHost()
					+ " , ";

			ExternalContext externalContext = FacesContext.getCurrentInstance()
					.getExternalContext();
			String userAgent = externalContext.getRequestHeaderMap().get(
					"User-Agent");

			cadenaConexion += userAgent;

			visitas.setCadenaConexion(cadenaConexion);

			visitas.setFechaTiempo(new Date());

			visitasDAO.register(visitas);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void grabarContacto() {

		try {
			contactoDAO.register(contacto);

			String url = "respuestaContacto.xhtml";
			FacesContext fc = FacesContext.getCurrentInstance();
			ExternalContext ec = fc.getExternalContext();
			try {
				ec.redirect(url);
			} catch (IOException ex) {

			}

		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	public void search() {

		flagSearch = "true";

		lBusqueda = busquedaDAO.findByTxtSearch(txtSearch);

	}

	public void gestBreadCrumb(String id, String p) {

		Integer iP = new Integer(p);

		int nEliminados = 0;

		List<MenuElement> lBreadCrumb = breadCrumb.getElements();

		BreadCrumbUrl breadCrumbUrl = new BreadCrumbUrl();

		for (int i = lBreadCrumb.size(); i >= iP; i--) {
			lBreadCrumb.remove(i - 1);
			lBreadCrumbUrl.remove(i - 1);
		}

	}

	public void fabricaPaginaVimeo() {

		String txtHtml = "";

		Integer iId = new Integer(idVimeo);

		Bloque bloque = new Bloque();

		lBloquesPag.clear();

		Media media = new Media();
		media = mediaDAO.findById(iId);

		txtHtml = "";

		addItemBreadCrumb("VIMEO", media.getTextoBreadCrumb(), idVimeo);

		txtHtml = txtHtml
				+ "<div class=\"tituloPagina\"><div class=\"txtTitulo\">"
				+ media.getTextoBreadCrumb() + "</div></div>";

		txtHtml = txtHtml
				+ "<div class=\"descripcionPagina\"><div class=\"txtTitulo\">"
				+ media.getTexto() + "</div></div>";

		txtHtml = txtHtml
				+ "<div class=\"cuerpoMedia\"><iframe src=\"//player.vimeo.com/video/"
				+ media.getFichero()
				+ "\"width=\"640px\" height=\"390px\" frameborder=\"0\" webkitallowfullscreen mozallowfullscreen allowfullscreen></iframe></div>";

		bloque.setTextoHtml(txtHtml);

		lBloquesPag.add(bloque);

	}

	public void fabricaPaginaFoto() {

		String txtHtml = "";

		Integer iId = new Integer(idFoto);

		Bloque bloque = new Bloque();

		lBloquesPag.clear();

		Media media = new Media();
		media = mediaDAO.findById(iId);

		txtHtml = "";

		addItemBreadCrumb("FOTO", media.getTextoBreadCrumb(), idFoto);

		txtHtml = txtHtml
				+ "<div class=\"tituloPagina\"><div class=\"txtTitulo\">"
				+ media.getTextoBreadCrumb() + "</div></div>";

		txtHtml = txtHtml
				+ "<div class=\"descripcionPagina\"><div class=\"txtTitulo\">"
				+ media.getTexto() + "</div></div>";

		txtHtml = txtHtml
				+ "<div class=\"cuerpoMedia\"><img src=\"resources/images/"
				+ media.getFichero() + "\" /></div>";

		bloque.setTextoHtml(txtHtml);

		lBloquesPag.add(bloque);

	}

	public void fabricaPagina() {

		int pesoBloque = 0;

		String style = "";

		String bloqueHtml = "";

		Integer iId = new Integer(idUrl);

		paginaidioma = new Paginaidioma();
		paginaidioma = paginaIdiomaDAO.findById(iId);

		addItemBreadCrumb("PAGINAIDIO", paginaidioma.getTextoBreadCrumb(),
				idUrl);

		String textoHtml = "";

		List<ContenidoPagina> list = new ArrayList(
				paginaidioma.getContenidoPaginas());

		Collections.sort(list, new OrdenarContenidoPorOrden());

		lBloquesPag.clear();

		Iterator<ContenidoPagina> i = list.iterator();

		while (i.hasNext()) {

			style = "  style=\"";

			ContenidoPagina contenidoPagina = (ContenidoPagina) i.next();

			Bloque bloque;
			bloque = contenidoPagina.getBloque();

			textoHtml = bloque.getTextoHtml();

			if (pesoBloque == 0) {
				bloqueHtml = "";
			}

			if (bloque.getColorBorde() != null
					&& !bloque.getColorBorde().equals("")) {
				style = style + " border:2px solid " + bloque.getColorBorde()
						+ "; ";
			}

			if (bloque.getImagenFondo() != null
					&& !bloque.getImagenFondo().equals("")) {
				style = style + "background-image:url('"
						+ bloque.getImagenFondo() + "'); ";
			}

			if (bloque.getColorFondo() != null
					&& !bloque.getColorFondo().equals("")) {
				style = style + "background-color:" + bloque.getColorFondo()
						+ "; ";
			}

			if (bloque.getColorLetra() != null
					&& !bloque.getColorLetra().equals("")) {
				style = style + " color:" + bloque.getColorLetra() + "; ";
			}

			style = style + "\" ";

			if (bloque.getFormato().getFormato().equals("TITULO")) {

				bloqueHtml = bloqueHtml
						+ "<div class=\"tituloPagina\"><div class=\"txtTitulo\">  ";

				bloqueHtml = bloqueHtml + paginaidioma.getTitulo();

				bloqueHtml = bloqueHtml + "</div></div>";

				contenidoPagina.getBloque().setTextoHtml(bloqueHtml);

				lBloquesPag.add(contenidoPagina.getBloque());
			}

			if (bloque.getFormato().getFormato().equals("DESCRIPCION")) {

				bloqueHtml = bloqueHtml
						+ "<div class=\"descripcionPagina\"><div class=\"txtTitulo\">  ";

				bloqueHtml = bloqueHtml
						+ paginaidioma.getTextoDescripcionCorta();

				bloqueHtml = bloqueHtml + "</div></div>";

				contenidoPagina.getBloque().setTextoHtml(bloqueHtml);

				lBloquesPag.add(contenidoPagina.getBloque());
			}

			if (bloque.getFormato().getFormato().equals("CUADRADOGRANDE")) {

				bloqueHtml = bloqueHtml + "<div class=\"blockFormat\"  "
						+ style + ">";

				Boolean isLink = false;

				if (bloque.getTipobloque() != null
						|| !bloque.getTipobloque().equals("")) {
					if (!bloque.getTipobloque().getTipo().equals("INFOGRAFIA")) {
						bloqueHtml = bloqueHtml
								+ "<div class=\"blockContent\" >";
					}

					bloqueHtml = bloqueHtml + textoHtml;

					if (bloque.getTipobloque() != null
							|| !bloque.getTipobloque().equals("")) {
						if (!bloque.getTipobloque().getTipo()
								.equals("INFOGRAFIA")) {
							bloqueHtml = bloqueHtml + "</div>";
						}
					}
				}

				bloqueHtml = bloqueHtml + "</div>";

				contenidoPagina.getBloque().setTextoHtml(bloqueHtml);

				lBloquesPag.add(contenidoPagina.getBloque());
			}

			if (bloque.getFormato().getFormato().equals("MAPA")) {

				bloqueHtml = bloqueHtml + "<div class=\"blockMapa\"  " + style
						+ ">";

				Boolean isLink = false;

				textoHtml = "<div style=\"position:absolute;width:99%;height:278px\" class=\"blockMapa blockContentInfoMapa\"  >";

				textoHtml = textoHtml + "<img src=\"resources/images/"
						+ bloque.getImagenFondo() + "\" usemap=\"#"
						+ bloque.getNombre() + "\" />";

				List<Bloquemarcador> bloquemarcadors = new ArrayList(
						bloque.getBloquemarcadors());

				Iterator<Bloquemarcador> iMarcadores = bloquemarcadors
						.iterator();

				while (iMarcadores.hasNext()) {

					Double x;
					Double y;

					Bloquemarcador marcadores = (Bloquemarcador) iMarcadores
							.next();

					if (marcadores.getMarcadores().getX() != null
							&& !marcadores.getMarcadores().getX().equals("")) {
						x = new Double(marcadores.getMarcadores().getX());
						y = new Double(marcadores.getMarcadores().getY());
						
					} else {

						Double lat = new Double(marcadores.getMarcadores()
								.getLatitud()).doubleValue();

						Double lon = new Double(marcadores.getMarcadores()
								.getLongitud()).doubleValue();

						int width = marcadores.getBloque().getWidth();
						int height = marcadores.getBloque().getHeight();
						// X and Y boundaries
						Double westLong = new Double(marcadores.getBloque()
								.getLongitudO());
						Double eastLong = new Double(marcadores.getBloque()
								.getLongitudE());
						Double northLat = new Double(marcadores.getBloque()
								.getLatitudN());
						Double southLat = new Double(marcadores.getBloque()
								.getLatitudS());

						x = width * ((westLong - lon) / (westLong - eastLong));
						y = (height * ((northLat - lat) / (northLat - southLat)));

					}

					textoHtml = textoHtml + "<img  onclick=\"";
					if (marcadores.getMarcadores().getTipoLink().equals("FOTO")) {
						textoHtml = textoHtml + "goFoto("
								+ marcadores.getMarcadores().getIdLink() + ") ";
					}

					if (marcadores.getMarcadores().equals("VIMEO")) {
						textoHtml = textoHtml + "goVimeo("
								+ marcadores.getMarcadores().getIdLink() + ") ";
					}

					if (marcadores.getMarcadores().getTipoLink()
							.equals("PAGINAIDIO")) {
						textoHtml = textoHtml + "goIdUrl("
								+ marcadores.getMarcadores().getIdLink() + ") ";
					}

					textoHtml = textoHtml
							+ "\"  src=\"resources/images/"
							+ marcadores.getMarcadores().getMarcador()
									.getFichero() + "\" ";
					textoHtml = textoHtml
							+ "style=\"cursor:pointer;position:absolute;top:"
							+ y
							+ "px;left:"
							+ x
							+ "px;"
							+ marcadores.getMarcadores().getMarcador()
									.getTamanyo()
							+ "\" height=\""
							+ marcadores.getMarcadores().getMarcador()
									.getTamanyo() + "\"  />";
				}

				textoHtml = textoHtml + "<map name=\"" + bloque.getNombre()
						+ "\">";

				textoHtml = textoHtml + "</map>";

				textoHtml = textoHtml + "</div>";

				bloqueHtml = bloqueHtml + textoHtml;

				if (bloque.getTipobloque() != null
						|| !bloque.getTipobloque().equals("")) {
					if (!bloque.getTipobloque().getTipo().equals("INFOGRAFIA")) {
						bloqueHtml = bloqueHtml + "</div>";
					}
				}

				bloqueHtml = bloqueHtml + "</div>";

				contenidoPagina.getBloque().setTextoHtml(bloqueHtml);

				lBloquesPag.add(contenidoPagina.getBloque());
			}

			if (bloque.getFormato().getFormato().equals("VERTICAL")) {

			}

			if (bloque.getFormato().getFormato().equals("CUADRADOPEQUE")) {

				if (pesoBloque == 0) {
					bloqueHtml = bloqueHtml
							+ "<div class=\"blockRectangle\" > ";

				}

				bloqueHtml = bloqueHtml + "<div class=\"squareNoLink\"  "
						+ style + ">";
				bloqueHtml = bloqueHtml + "<div class=\"squareLinkContent\">"
						+ textoHtml + "</div>";

				if (bloque.getLink() != null && !bloque.getLink().equals("")) {

					if (bloque.getTipoLink().equals("PAGINAIDIO")) {

						bloqueHtml = bloqueHtml
								+ "<img onclick=\"goIdUrl("
								+ bloque.getLink()
								+ ")\" src=\"resources/images/linkSquare.png\" style=\"cursor:pointer;\"></img></a>";
					}

					if (bloque.getTipoLink().equals("VIMEO")) {

						bloqueHtml = bloqueHtml
								+ "<img onclick=\"goVimeo(\'"
								+ bloque.getLink()
								+ "\')\" src=\"resources/images/linkSquare.png\" style=\"cursor:pointer;\"></img></a>";
					}
				}
				bloqueHtml = bloqueHtml + "</div>";

				pesoBloque++;

				if (pesoBloque == 2 || (pesoBloque == 1 && !i.hasNext())) {
					bloqueHtml = bloqueHtml + "</div>";
					pesoBloque = 0;

					contenidoPagina.getBloque().setTextoHtml(bloqueHtml);

					lBloquesPag.add(contenidoPagina.getBloque());
				}
			}

			if (bloque.getFormato().getFormato().equals("HORIZONTAL")) {

			}

		}

	}

	public void addItemBreadCrumb(String tipus, String titulo, String id) {

		boolean flagRepe = false;

		if (lBreadCrumbUrl.size() > 0) {
			if (lBreadCrumbUrl.get(lBreadCrumbUrl.size() - 1).getId()
					.equals(id)
					&& lBreadCrumbUrl.get(lBreadCrumbUrl.size() - 1).getTipus()
							.equals(tipus)) {
				flagRepe = true;
			}
		}

		if (!flagRepe) {

			pagActual = id;
			tipusActual = tipus;

			if (!flagSearch.equals("true")) {

				if (indexBread != "") {
					gestBreadCrumb(id, indexBread);
				}

				Integer ultBread = lBreadCrumbUrl.size() + 1;

				DefaultMenuItem itemHome = new DefaultMenuItem("guia");
				itemHome.setValue(titulo);
				itemHome.setId(nBreadCrumb.toString());

				indexBread = "";

				ultimoIdBread = id;

				String f = "goBreadCrumb('" + id + "','" + ultBread + "','"
						+ tipus + "');";

				itemHome.setOnclick(f);

				breadCrumb.addElement(itemHome);

				BreadCrumbUrl breadCrumbUrl = new BreadCrumbUrl();

				breadCrumbUrl.setItem(lBreadCrumbUrl.size() + 1);

				breadCrumbUrl.setTipus(tipus);

				breadCrumbUrl.setId(id);

				lBreadCrumbUrl.add(breadCrumbUrl);

				nBreadCrumb++;
			}

		}

	}

	public void fabricaPaginaIframe() {

		String txtHtml = "";

		Integer iId = new Integer(idFrame);

		Bloque bloque = new Bloque();

		lBloquesPag.clear();

		Media media = new Media();
		media = mediaDAO.findById(iId);

		txtHtml = "";

		addItemBreadCrumb("IFRAME", media.getTextoBreadCrumb(), idFrame);

		txtHtml = txtHtml
				+ "<div class=\"tituloPagina\"><div class=\"txtTitulo\">"
				+ media.getTextoBreadCrumb() + "</div></div>";

		txtHtml = txtHtml
				+ "<div class=\"descripcionPagina\"><div class=\"txtTitulo\">"
				+ media.getTexto() + "</div></div>";

		txtHtml = txtHtml
				+ "<iframe id=\"idFrame\" width=960 height=400 src=\""
				+ media.getFichero() + "\" /></iframe>";

		bloque.setTextoHtml(txtHtml);

		lBloquesPag.add(bloque);

	}

	public List<Bloque> getlBloquesPag() {

		return lBloquesPag;
	}

	public void setlBloquesPag(List<Bloque> lBloquesPag) {
		this.lBloquesPag = lBloquesPag;
	}

	public void setPaginaidioma(Paginaidioma paginaidioma) {
		this.paginaidioma = paginaidioma;
	}

	public String getIdUrl() {
		return idUrl;
	}

	public void setIdUrl(String idUrl) {
		this.idUrl = idUrl;
	}

	public String getIdFoto() {
		return idFoto;
	}

	public void setIdFoto(String idFoto) {
		this.idFoto = idFoto;
	}

	public String getIdVimeo() {
		return idVimeo;
	}

	public void setIdVimeo(String idVimeo) {
		this.idVimeo = idVimeo;
	}

	public MenuModel getBreadCrumb() {

		return breadCrumb;
	}

	public void setBreadCrumb(MenuModel breadCrumb) {

		this.breadCrumb = breadCrumb;
	}

	public String getTxtSearch() {
		return txtSearch;
	}

	public void setTxtSearch(String txtSearch) {
		this.txtSearch = txtSearch;
	}

	public List<Busqueda> getlBusqueda() {
		return lBusqueda;
	}

	public void setlBusqueda(List<Busqueda> lBusqueda) {
		this.lBusqueda = lBusqueda;
	}

	public String getIndexBread() {
		return indexBread;
	}

	public void setIndexBread(String indexBread) {
		this.indexBread = indexBread;
	}

	public String getFlagSearch() {
		return flagSearch;
	}

	public void setFlagSearch(String flagSearch) {
		this.flagSearch = flagSearch;
	}

	public String getPagActual() {
		return pagActual;
	}

	public void setPagActual(String pagActual) {
		this.pagActual = pagActual;
	}

	public String getTipusActual() {
		return tipusActual;
	}

	public void setTipusActual(String tipusActual) {
		this.tipusActual = tipusActual;
	}

	public String getIdParam() {
		return idParam;
	}

	public void setIdParam(String idParam) {
		this.idParam = idParam;
	}

	public String getIdFrame() {
		return idFrame;
	}

	public void setIdFrame(String idFrame) {
		this.idFrame = idFrame;
	}

	public Contacto getContacto() {
		return contacto;
	}

	public void setContacto(Contacto contacto) {
		this.contacto = contacto;
	}
}
