package guiaModernismo.controller;

import guiaModernismo.comparators.OrdenarContenidoPorOrden;
import guiaModernismo.dao.MediaDAO;
import guiaModernismo.dao.PaginaIdiomaDAO;
import guiaModernismo.model.Bloque;
import guiaModernismo.model.Bloquemarcador;
import guiaModernismo.model.BreadCrumbUrl;
import guiaModernismo.model.ContenidoPagina;
import guiaModernismo.model.Media;
import guiaModernismo.model.Paginaidioma;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;
import javax.inject.Inject;

import org.primefaces.model.menu.DefaultMenuModel;
import org.primefaces.model.menu.MenuModel;

@ManagedBean
@ViewScoped
public class MobileGuiaModernismoController implements Serializable {

	@Inject
	private PaginaIdiomaDAO paginaIdiomaDAO;

	@Inject
	private MediaDAO mediaDAO;

	public Paginaidioma paginaidioma;

	public String idUrl = "1";

	public String idFoto = "";

	public String idVimeo = "";

	public List<BreadCrumbUrl> lBreadCrumbUrl = new ArrayList<BreadCrumbUrl>();

	MenuModel breadCrumb = new DefaultMenuModel();
	Integer nBreadCrumb = 0;

	public List<Bloque> lBloquesPag = new ArrayList<Bloque>();

	public List<Bloque> lFotosStorage = new ArrayList<Bloque>();
	
	public List<Bloque> lFormato = new ArrayList<Bloque>();

	public List<Bloque> lTitulosStorage = new ArrayList<Bloque>();

	public List<Bloque> lTextosStorage = new ArrayList<Bloque>();

	public MobileGuiaModernismoController() {

	}

	public Paginaidioma getPaginaidioma() {

		return paginaidioma;
	}

	public int id;

	public void fabricaPaginaVimeo() {

		String txtHtml = "";

		Integer iId = new Integer(idVimeo);

		Bloque bloque = new Bloque();

		lBloquesPag.clear();

		Media media = new Media();
		media = mediaDAO.findById(iId);

		txtHtml = media.getTexto();

		txtHtml = txtHtml
				+ "<iframe src=\"//player.vimeo.com/video/"
				+ media.getFichero()
				+ "\"width=\"320px\" height=\"240px\" frameborder=\"0\" webkitallowfullscreen mozallowfullscreen allowfullscreen></iframe>";

		bloque.setTextoHtml(txtHtml);

		lBloquesPag.add(bloque);

	}

	public void fabricaPaginaFoto() {

		String txtHtml = "";

		Integer iId = new Integer(idFoto);

		Bloque bloque = new Bloque();

		lBloquesPag.clear();

		Media media = new Media();
		media = mediaDAO.findById(iId);

		txtHtml = "";

		txtHtml = txtHtml
				+ "<div class=\"tituloPagina\"><div class=\"txtTitulo\">"
				+ media.getTextoBreadCrumb() + "</div></div>";

		txtHtml = txtHtml
				+ "<div class=\"descripcionPagina\"><div class=\"txtTitulo\">"
				+ media.getTexto() + "</div></div>";
		if (media.getFormato() == 1) {
			txtHtml = txtHtml
					+ "<img width=\"320px\" height=\"240px\" src=\"resources/images/"
					+ media.getFichero() + "\" />";
		}

		if (media.getFormato() == 2) {
			txtHtml = txtHtml
					+ "<img width=\"320px\" height=\"427px\" src=\"resources/images/"
					+ media.getFichero() + "\" />";
		}

		bloque.setTextoHtml(txtHtml);

		lBloquesPag.add(bloque);

	}

	public void fabricaPagina(Integer pagina) {

		int pesoBloque = 0;

		String style = "";

		String textoHtml = "";

		String bloqueHtml = "";

		Integer iId = new Integer(pagina);

		paginaidioma = new Paginaidioma();
		paginaidioma = paginaIdiomaDAO.findById(iId);

		List<ContenidoPagina> list = new ArrayList(
				paginaidioma.getContenidoPaginas());

		Collections.sort(list, new OrdenarContenidoPorOrden());

		Iterator<ContenidoPagina> i = list.iterator();

		while (i.hasNext()) {

			style = "  style=\"";

			ContenidoPagina contenidoPagina = (ContenidoPagina) i.next();

			Bloque bloque;
			bloque = contenidoPagina.getBloque();

			textoHtml = bloque.getTextoHtml();

			if (pesoBloque == 0) {
				bloqueHtml = "";
			}

			if (bloque.getColorBorde() != null
					&& !bloque.getColorBorde().equals("")) {
				style = style + " border:2px solid " + bloque.getColorBorde()
						+ "; ";
			}

			if (bloque.getImagenFondo() != null
					&& !bloque.getImagenFondo().equals("")) {
				style = style + "background-image:url('"
						+ bloque.getImagenFondo() + "'); ";
			}

			if (bloque.getColorFondo() != null
					&& !bloque.getColorFondo().equals("")) {
				style = style + "background-color:" + bloque.getColorFondo()
						+ "; ";
			}

			if (bloque.getColorLetra() != null
					&& !bloque.getColorLetra().equals("")) {
				style = style + " color:" + bloque.getColorLetra() + "; ";
			}

			style = style + "\" ";

			if (bloque.getFormato().getFormato().equals("TITULO")) {

				bloqueHtml = bloqueHtml
						+ "<div class=\"tituloPagina\"><div class=\"txtTitulo\">  ";

				bloqueHtml = bloqueHtml + paginaidioma.getTitulo();

				bloqueHtml = bloqueHtml + "</div></div>";

				contenidoPagina.getBloque().setTextoHtml(bloqueHtml);

				lBloquesPag.add(contenidoPagina.getBloque());
			}

			if (bloque.getFormato().getFormato().equals("DESCRIPCION")) {

				bloqueHtml = bloqueHtml
						+ "<div class=\"descripcionPagina\"><div class=\"txtTitulo\">  ";

				bloqueHtml = bloqueHtml
						+ paginaidioma.getTextoDescripcionCorta();

				bloqueHtml = bloqueHtml + "</div></div>";

				contenidoPagina.getBloque().setTextoHtml(bloqueHtml);

				lBloquesPag.add(contenidoPagina.getBloque());
			}

			if (bloque.getFormato().getFormato().equals("CUADRADOGRANDE")) {

				bloqueHtml = bloqueHtml + "<div class=\"blockFormat\"  "
						+ style + ">";

				Boolean isLink = false;

				if (bloque.getTipobloque() != null
						|| !bloque.getTipobloque().equals("")) {
					if (!bloque.getTipobloque().getTipo().equals("INFOGRAFIA")) {
						bloqueHtml = bloqueHtml
								+ "<div class=\"blockContent\" >";
					}

					bloqueHtml = bloqueHtml + textoHtml;

					if (bloque.getTipobloque() != null
							|| !bloque.getTipobloque().equals("")) {
						if (!bloque.getTipobloque().getTipo()
								.equals("INFOGRAFIA")) {
							bloqueHtml = bloqueHtml + "</div>";
						}
					}
				}

				bloqueHtml = bloqueHtml + "</div>";

				contenidoPagina.getBloque().setTextoHtml(bloqueHtml);

				lBloquesPag.add(contenidoPagina.getBloque());
			}

			if (bloque.getFormato().getFormato().equals("MAPA")) {

				bloqueHtml = bloqueHtml + "<div class=\"blockMapa\"  " + style
						+ ">";

				Boolean isLink = false;

				textoHtml = "<div style=\"position:absolute;width:99%;height:278px\" class=\"blockMapa blockContentInfoMapa\"  >";

				textoHtml = textoHtml + "<img src=\"resources/images/"
						+ bloque.getImagenFondo() + "\" usemap=\"#"
						+ bloque.getNombre() + "\" />";

				List<Bloquemarcador> bloquemarcadors = new ArrayList(
						bloque.getBloquemarcadors());

				Iterator<Bloquemarcador> iMarcadores = bloquemarcadors
						.iterator();

				while (iMarcadores.hasNext()) {
					
					Double x;
					Double y;

					Bloquemarcador marcadores = (Bloquemarcador) iMarcadores
							.next();

					if (marcadores.getMarcadores().getX() != null
							&& !marcadores.getMarcadores().getX().equals("")) {
						x = new Double(marcadores.getMarcadores().getX());
						y = new Double(marcadores.getMarcadores().getY());
						
					} else {

						Double lat = new Double(marcadores.getMarcadores()
								.getLatitud()).doubleValue();

						Double lon = new Double(marcadores.getMarcadores()
								.getLongitud()).doubleValue();

						int width = marcadores.getBloque().getWidth();
						int height = marcadores.getBloque().getHeight();
						// X and Y boundaries
						Double westLong = new Double(marcadores.getBloque()
								.getLongitudO());
						Double eastLong = new Double(marcadores.getBloque()
								.getLongitudE());
						Double northLat = new Double(marcadores.getBloque()
								.getLatitudN());
						Double southLat = new Double(marcadores.getBloque()
								.getLatitudS());

						x = width * ((westLong - lon) / (westLong - eastLong));
						y = (height * ((northLat - lat) / (northLat - southLat)));

					}
					
					textoHtml = textoHtml + "<img  onclick=\"";
					if (marcadores.getMarcadores().getTipoLink().equals("FOTO")) {
						textoHtml = textoHtml + "goFoto("
								+ marcadores.getMarcadores().getIdLink() + ") ";
					}

					if (marcadores.getMarcadores().equals("VIMEO")) {
						textoHtml = textoHtml + "goVimeo("
								+ marcadores.getMarcadores().getIdLink() + ") ";
					}

					if (marcadores.getMarcadores().getTipoLink()
							.equals("PAGINAIDIO")) {
						
						Paginaidioma paginaIdUrl = paginaIdiomaDAO.findById(new Integer(marcadores.getMarcadores().getIdLink()));
						
						textoHtml = textoHtml + "goIdUrl(''"
								+ paginaIdUrl.getTextoDescripcionCorta() + "') ";
					}

					textoHtml = textoHtml
							+ "\"  src=\"resources/images/"
							+ marcadores.getMarcadores().getMarcador()
									.getFichero() + "\" ";
					textoHtml = textoHtml
							+ "style=\"cursor:pointer;position:absolute;top:"
							+ y
							+ "px;left:"
							+ x
							+ "px;"
							+ marcadores.getMarcadores().getMarcador()
									.getTamanyo()
							+ "\" height=\""
							+ marcadores.getMarcadores().getMarcador()
									.getTamanyo() + "\"  />";
				}

				textoHtml = textoHtml + "<map name=\"" + bloque.getNombre()
						+ "\">";

				textoHtml = textoHtml + "</map>";

				textoHtml = textoHtml + "</div>";

				bloqueHtml = bloqueHtml + textoHtml;

				if (bloque.getTipobloque() != null
						|| !bloque.getTipobloque().equals("")) {
					if (!bloque.getTipobloque().getTipo().equals("INFOGRAFIA")) {
						bloqueHtml = bloqueHtml + "</div>";
					}
				}

				bloqueHtml = bloqueHtml + "</div>";

				contenidoPagina.getBloque().setTextoHtml(bloqueHtml);

				lBloquesPag.add(contenidoPagina.getBloque());
			}

			if (bloque.getFormato().getFormato().equals("VERTICAL")) {

			}

			if (bloque.getFormato().getFormato().equals("CUADRADOPEQUE")) {

				if (pesoBloque == 0) {
					bloqueHtml = bloqueHtml
							+ "<div class=\"blockRectangle\" > ";

				}

				bloqueHtml = bloqueHtml + "<div class=\"squareNoLink\"  "
						+ style + ">";
				bloqueHtml = bloqueHtml + "<div class=\"squareLinkContent\">"
						+ textoHtml + "</div>";

				if (bloque.getLink() != null && !bloque.getLink().equals("")) {

					if (bloque.getTipoLink().equals("PAGINAIDIO")) {

						Paginaidioma paginaidiomago = new Paginaidioma();
						paginaidiomago = paginaIdiomaDAO.findById(new Integer(
								bloque.getLink()));

						bloqueHtml = bloqueHtml
								+ "<img onclick=\"goIdUrl('"
								+ paginaidiomago.getTextoDescripcionCorta()
								+ "')\" src=\"resources/images/linkSquare.png\" style=\"cursor:pointer;\"></img></a>";
					}

					if (bloque.getTipoLink().equals("VIMEO")) {

						bloqueHtml = bloqueHtml
								+ "<img onclick=\"goVimeo(\'"
								+ bloque.getLink()
								+ "\')\" src=\"resources/images/linkSquare.png\" style=\"cursor:pointer;\"></img></a>";
					}
				}
				bloqueHtml = bloqueHtml + "</div>";

				pesoBloque++;

				if (pesoBloque == 2 || (pesoBloque == 1 && !i.hasNext())) {
					bloqueHtml = bloqueHtml + "</div>";
					pesoBloque = 0;

					contenidoPagina.getBloque().setTextoHtml(bloqueHtml);

					lBloquesPag.add(contenidoPagina.getBloque());
				}
			}

			if (bloque.getFormato().getFormato().equals("HORIZONTAL")) {

			}

		}

	}

	public List<Bloque> getlBloquesPag() {

		Bloque bloque;

		List<Paginaidioma> lPaginaidioma = new ArrayList<Paginaidioma>();

		lPaginaidioma = (List<Paginaidioma>) paginaIdiomaDAO
				.findByIdioma("Español");

		for (int j = 0; j < lPaginaidioma.size(); j++) {

			bloque = new Bloque();

			bloque.setTextoHtml("<div id=\""
					+ lPaginaidioma.get(j).getTextoDescripcionCorta().trim()
					+ "\" style=\"display:none\" class=\"ver\">");

			lBloquesPag.add(bloque);

			fabricaPagina(lPaginaidioma.get(j).getId());

			bloque = new Bloque();

			bloque.setTextoHtml("</div>");

			lBloquesPag.add(bloque);
		}

		return lBloquesPag;
	}

	public void setlBloquesPag(List<Bloque> lBloquesPag) {
		this.lBloquesPag = lBloquesPag;
	}

	public void setPaginaidioma(Paginaidioma paginaidioma) {
		this.paginaidioma = paginaidioma;
	}

	public String getIdUrl() {
		return idUrl;
	}

	public void setIdUrl(String idUrl) {
		this.idUrl = idUrl;
	}

	public String getIdFoto() {
		return idFoto;
	}

	public void setIdFoto(String idFoto) {
		this.idFoto = idFoto;
	}

	public String getIdVimeo() {
		return idVimeo;
	}

	public void setIdVimeo(String idVimeo) {
		this.idVimeo = idVimeo;
	}

	public MenuModel getBreadCrumb() {

		return breadCrumb;
	}

	public void setBreadCrumb(MenuModel breadCrumb) {

		this.breadCrumb = breadCrumb;
	}

	public List<Bloque> getlFotosStorage() {

		Bloque bloque;

		List<Media> lMedia = new ArrayList<Media>();

		lMedia = (List<Media>) mediaDAO.findFotos();

		for (Integer j = 0; j < lMedia.size(); j++) {

			bloque = new Bloque();

			bloque.setTextoHtml("localStorage[\"f" + lMedia.get(j).getId().toString() + "\"] = \""
					+ lMedia.get(j).getFichero() + " \";");

			lFotosStorage.add(bloque);

		}

		return lFotosStorage;
	}

	public void setlFotosStorage(List<Bloque> lFotosStorage) {
		this.lFotosStorage = lFotosStorage;
	}

	public List<Bloque> getlTitulosStorage() {
		
		Bloque bloque;

		List<Media> lMedia = new ArrayList<Media>();

		lMedia = (List<Media>) mediaDAO.findFotos();

		for (Integer j = 0; j < lMedia.size(); j++) {

			bloque = new Bloque();

			bloque.setTextoHtml("localStorage[\"tit" + lMedia.get(j).getId().toString() + "\"] = \""
					+ lMedia.get(j).getTextoBreadCrumb() + " \";");

			lTitulosStorage.add(bloque);

		}
		
		return lTitulosStorage;
	}

	public void setlTitulosStorage(List<Bloque> lTitulosStorage) {
		this.lTitulosStorage = lTitulosStorage;
	}

	public List<Bloque> getlTextosStorage() {
		
		Bloque bloque;

		List<Media> lMedia = new ArrayList<Media>();

		lMedia = (List<Media>) mediaDAO.findFotos();

		for (Integer j = 0; j < lMedia.size(); j++) {

			bloque = new Bloque();

			bloque.setTextoHtml("localStorage[\"tex" + lMedia.get(j).getId().toString() + "\"] = \""
					+ lMedia.get(j).getTexto() + " \";");

			lTextosStorage.add(bloque);

		}
		
		return lTextosStorage;
	}

	public void setlTextosStorage(List<Bloque> lTextosStorage) {
		this.lTextosStorage = lTextosStorage;
	}

	public List<Bloque> getlFormato() {
		
		Bloque bloque;

		List<Media> lMedia = new ArrayList<Media>();

		lMedia = (List<Media>) mediaDAO.findFotos();

		for (Integer j = 0; j < lMedia.size(); j++) {

			bloque = new Bloque();

			bloque.setTextoHtml("localStorage[\"for" + lMedia.get(j).getId().toString() + "\"] = \""
					+ lMedia.get(j).getFormato() + " \";");

			lFormato.add(bloque);

		}
		
		return lFormato;
	}

	public void setlFormato(List<Bloque> lFormato) {
		
		this.lFormato = lFormato;
	}
}
